/**
 * Find Options Operator.
 * Example: { someField: MoreThan(10) }
 */
import {FindOperator} from "../FindOperator";

export function And<T>(value: T | FindOperator<T>): FindOperator<T> {
    return new FindOperator("and", value)
}

export function Any<T>(value: T[] | FindOperator<T>): FindOperator<T> {
    return new FindOperator("any", value as any, true, true)
}

export function Contains<T>(value: T | FindOperator<T>): FindOperator<T> {
    return new FindOperator("contains", value)
}

export function EndsWith<T>(value: T | FindOperator<T>): FindOperator<T> {
    return new FindOperator("endsWith", value)
}

export function Equals<T>(value: T | FindOperator<T>): FindOperator<T> {
    return new FindOperator("equal", value)
}

export function GreaterThan<T>(value: T | FindOperator<T>): FindOperator<T> {
    return new FindOperator("greaterThan", value)
}

export function GreaterThanOrEqual<T>(value: T | FindOperator<T>): FindOperator<T> {
    return new FindOperator("greaterOrEqual", value)
}

export function Has<T>(value: T[] | FindOperator<T>): FindOperator<T> {
    return new FindOperator("has", value as any, true, true)
}

export function LessThan<T>(value: T | FindOperator<T>): FindOperator<T> {
    return new FindOperator("lessThan", value)
}

export function LessThanOrEqual<T>(value: T | FindOperator<T>): FindOperator<T> {
    return new FindOperator("lessThanOrEqual", value)
}

export function Not<T>(value: T | FindOperator<T>): FindOperator<T> {
    return new FindOperator("not", value)
}

export function Or<T>(value: T | FindOperator<T> | FindOperator<T>[]): FindOperator<T> {
    return new FindOperator("or", value)
}

export function StartsWith<T>(value: T | FindOperator<T>): FindOperator<T> {
    return new FindOperator("startsWith", value)
}
